* macros_random_samples_based_on_criteria.SPS.
* Create indicator variables of cases randomly selected based
  on given criteria.
SET MPRINT=OFF.

DEFINE !select (
    nb1=!TOKENS(1)   /crit1=!ENCLOSE('(',')')
   /nb2=!TOKENS(1)   /crit2=!ENCLOSE('(',')')
   /FPath=!TOKENS(1) /RPath=!TOKENS(1))
GET FILE=!FPath.
COMPUTE casenum=$CASENUM.
SAVE OUTFILE='c:\temp\temp.sav'.
SHOW SEED.
!DO !cnt=1 !TO 2
- SELECT IF !IF (!cnt=1) !THEN !crit1 !ELSE !crit2 !IFEND.
- COMPUTE draw=UNIFORM(1).
- SORT CASES BY draw.
- N OF CASES !IF (!cnt=1) !THEN !nb1 !ELSE !nb2 !IFEND.
- SORT CASES BY casenum.
- SAVE OUTFILE=!QUOTE(!CONCAT('c:\temp\group',!cnt,'.sav.')).
- GET FILE='c:\temp\temp.sav'.
!DOEND
MATCH FILES FILE=*
   /FILE='c:\temp\group1.sav'
   /IN=ingrp1
   /FILE='c:\temp\group2.sav'
   /IN=ingrp2
   /BY=casenum
  /DROP=draw.
SAVE OUTFILE=!RPath.
!ENDDEFINE.
 
SET MPRINT=ON.
!select nb1=5  crit1=(gender='m' AND jobcat=1 AND educ<16)
        nb2=7  crit2=(gender='f' AND jobcat=1 AND educ>11)
        FPath= 'c:\examples\data\employee data.sav'
        RPath= 'c:\temp\results.sav'.

* List cases selected by criteria 1.
DO IF ingrp1=1.
+ PRINT /id ingrp1 gender jobcat educ.
END IF.
EXECUTE.
